<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑医生' : '添加医生'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
<!--      <a-form-item label="类型 0经销商 1企业 2集团" name="type">-->
<!--        <a-input-->
<!--          allow-clear-->
<!--          placeholder="请输入类型 0经销商 1企业 2集团"-->
<!--          v-model:value="form.type"-->
<!--        />-->
<!--      </a-form-item>-->
<!--      <a-form-item label="自增ID" name="userId">-->
<!--        <a-input-->
<!--          allow-clear-->
<!--          placeholder="请输入自增ID"-->
<!--          v-model:value="form.userId"-->
<!--        />-->
<!--      </a-form-item>-->
      <a-form-item label="姓名" name="realName">
        <a-input
          allow-clear
          placeholder="请输入姓名"
          v-model:value="form.realName"
        />
      </a-form-item>
      <a-form-item label="部门" name="departmentId">
        <a-input
          allow-clear
          placeholder="请输入部门"
          v-model:value="form.departmentId"
        />
      </a-form-item>
      <a-form-item label="专业领域" name="specialty">
        <a-input
          allow-clear
          placeholder="请输入专业领域"
          v-model:value="form.specialty"
        />
      </a-form-item>
      <a-form-item label="职务级别" name="position">
        <a-input
          allow-clear
          placeholder="请输入职务级别"
          v-model:value="form.position"
        />
      </a-form-item>
      <a-form-item label="执业资格" name="qualification">
        <a-input
          allow-clear
          placeholder="请输入执业资格"
          v-model:value="form.qualification"
        />
      </a-form-item>
      <a-form-item label="医生简介" name="introduction">
        <a-input
          allow-clear
          placeholder="请输入医生简介"
          v-model:value="form.introduction"
        />
      </a-form-item>
      <a-form-item label="挂号费" name="consultationFee">
        <a-input
          allow-clear
          placeholder="请输入挂号费"
          v-model:value="form.consultationFee"
        />
      </a-form-item>
      <a-form-item label="工作年限" name="workYears">
        <a-input
          allow-clear
          placeholder="请输入工作年限"
          v-model:value="form.workYears"
        />
      </a-form-item>
      <a-form-item label="问诊人数" name="consultationCount">
        <a-input
          allow-clear
          placeholder="请输入问诊人数"
          v-model:value="form.consultationCount"
        />
      </a-form-item>
      <a-form-item label="专属二维码" name="qrcode">
        <a-input
          allow-clear
          placeholder="请输入专属二维码"
          v-model:value="form.qrcode"
        />
      </a-form-item>
      <a-form-item label="备注" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
      <a-form-item label="排序号" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addClinicDoctorUser, updateClinicDoctorUser } from '@/api/clinic/clinicDoctorUser';
  import { ClinicDoctorUser } from '@/api/clinic/clinicDoctorUser/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ClinicDoctorUser | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ClinicDoctorUser>({
    id: undefined,
    type: undefined,
    userId: undefined,
    realName: undefined,
    departmentId: undefined,
    specialty: undefined,
    position: undefined,
    qualification: undefined,
    introduction: undefined,
    consultationFee: undefined,
    workYears: undefined,
    consultationCount: undefined,
    qrcode: undefined,
    comments: undefined,
    isDelete: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    clinicDoctorUserName: [
      {
        required: true,
        type: 'string',
        message: '请填写医生名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateClinicDoctorUser : addClinicDoctorUser;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
